<%-- $Id: view_configuration.jsp 6592 2014-11-12 12:58:23Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.ToStringComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.TreeSet"
	import="java.util.List"
	import="java.util.Collections"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PLUGINCONFIGURATION;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String root = request.getContextPath() + "/";
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);

	String title = null;
	PluginConfiguration configuration = PluginConfiguration.getById(dc, itemId);
	
	final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
	final boolean writePermission = configuration.hasPermission(Permission.WRITE);
	final boolean deletePermission = configuration.hasPermission(Permission.DELETE);
	final boolean sharePermission = configuration.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = configuration.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = configuration.isRemoved();
	final boolean isUsed = isRemoved && configuration.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = configuration.isOwner();

	final Set<GuiContext> contexts = new TreeSet<GuiContext>(new ToStringComparator<GuiContext>(false));
	PluginDefinition plugin = null;
	Nameable nameableProxy = null;
	boolean readPlugin = true;
	boolean configurable = false;
	try
	{
		plugin = configuration.getPluginDefinition();
		contexts.addAll(plugin.getGuiContexts());
		configurable = plugin.isInteractive() && plugin.supportsConfigurations();
	}
	catch (PermissionDeniedException ex)
	{
		readPlugin = false;
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, configuration);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~configurations.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Plugin configurations" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(configuration.getName())%>" 
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=configuration.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this plugin configuration" : "You do not have permission to edit this plugin configuration"%>" 
						/>
						<tbl:button 
							id="btnCopy"
							disabled="<%=!createPermission%>" 
							image="copy.png"
							title="Copy&hellip;" 
							tooltip="<%=createPermission ? "Create a copy of this configuration" : "You do not have permission to create new configurations"%>"
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!configuration.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this plugin configuration" : "You do not have permission to delete this plugin configuration"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=configuration.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this plugin configuration" : "You do not have permission to restore this plugin configuration"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this plugin configuration to other user, groups and projects" : "You do not have permission to share this plugin configuration"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<tbl:button
							id="btnConfigure"
							image="runplugin.png"
							title="Configure&hellip;"
							tooltip="Configure this plugin"
							visible="<%=configurable && writePermission%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="pluginconfiguration.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(configuration.getName())%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(configuration.getEntryDate())%></td>
			</tr>
			<tr>
				<th>Plugin</th>
				<td><%=Base.getLinkedName(ID, plugin, plugin == null, true)%></td>
			</tr>
			<tr>
				<th>Type</th>
				<td><%=plugin == null ? "<i>- denied -</i>" : plugin.getMainType().toString()%></td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=configuration%>" property="owner" /></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(configuration)%></td>
			</tr>
			<tr >
				<th>Description</th>
				<td><%=HTML.niceFormat(configuration.getDescription())%></td>
			</tr>
			</table>
			</div>
			
			<%
			if (plugin != null)
			{
				List<String> names = new java.util.ArrayList<String>(configuration.getParameterNames());
				%>
				<base:section
					id="parameters"
					title="Configuration parameters"
					context="<%=cc %>"
					>
					<%
					if (names == null || names.size() == 0)
					{
						%>
						<div class="messagecontainer note">
						No parameters has been specified.
						</div>
						<%
					}
					else
					{
						Collections.sort(names);
						%>
						<table class="fullform fullborder">
							<%
							for (String name : names)
							{
								StringBuilder sb = new StringBuilder();
								String displayValue = "";
								String description = "";
								try
								{
									ParameterInfo pi = configuration.getParameterInfo(name);
									if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
									description = HTML.encodeTags(pi.getDescription());
									List<?> values = pi.getValues();
									int i = 0;
									for (Object value : values)
									{
										if (value != null)
										{
											if (i > 0) sb.append(", ");
											i++;
											if (value instanceof BasicItem)
											{
												BasicItem item = (BasicItem)value;
												String itemName = "";
												if (item instanceof File)
												{
													sb.append(Base.getLinkedFile(ID, (File)item, false, true, true, root));
												}
												else 
												{
													if (item instanceof Nameable)
													{
														itemName = ((Nameable)item).getName();
													}
													else
													{
														itemName = item.toString();
													}
													sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
														item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
												}
											}
											else if (value instanceof Date)
											{
												if (pi.getValueType() == Type.TIMESTAMP)
												{
													sb.append(dateTimeFormatter.format((Date)value));
												}
												else
												{
													sb.append(dateFormatter.format((Date)value));
												}
											}
											else
											{
												sb.append(HTML.encodeTags(value.toString()));
											}
										}
									}
									displayValue = sb.toString();
								}
								catch (Throwable ex)
								{
									displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
								}
								%>
								<tr>
									<th><span title="<%=description%>"><%=name%></span></th>
									<td><%=displayValue%></td>
								</tr>
								<%
							}
							%>
						</table>
						<%
					}
					%>
				</base:section>
				<%
			}
			%>
			
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this plugin configuration" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" clazz="white"
				visible="<%=plugin != null && plugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin") %>">
				<jsp:include page="../../common/annotations/list_frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<jsp:include page="../../common/history/frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
