<%-- $Id: view_transformation.jsp 6388 2014-01-07 10:52:36Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.Transformation"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.TRANSFORMATION;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tabId = Values.getString(request.getParameter("tab"), "properties");

final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Transformation transformation = Transformation.getById(dc, itemId);
	Experiment experiment = transformation.getExperiment();
	int experimentId = experiment.getId();
	RawDataType rawDataType = experiment.getRawDataType();
	
	Job job = null;
	boolean readJob = true;
	PluginDefinition plugin = null;
	boolean readPlugin = true;
	PluginConfiguration configuration = null;
	boolean readConfiguration = true;

	try
	{
		job = transformation.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
		readPlugin = false;
		readConfiguration = false;
	}
	if (job != null)
	{
		try
		{
			plugin = job.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readPlugin = false;
		}
		try
		{
			configuration = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readConfiguration = false;
		}
	}
	
	final boolean writePermission = transformation.hasPermission(Permission.WRITE);
	final boolean deletePermission = transformation.hasPermission(Permission.DELETE);
	boolean copyTransformationAllowed = false;
	if (plugin != null && plugin.isInteractive() && plugin.hasPermission(Permission.USE))
	{
		if (configuration == null || configuration.hasPermission(Permission.USE))
		{
			copyTransformationAllowed = true;
		}
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, transformation);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~transformations.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,joust-2.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Experiments" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../bioassaysets/index.jsp?ID="+ID+"&amp;experiment_id="+experimentId%>" 
			/><p:pathelement title="<%=HTML.encodeTags(transformation.getName())%>" 
			/></p:path>
		<div id="page-data" 
			data-item-id="<%=itemId%>"
			data-experiment-id="<%=experimentId%>"
			data-job-id="<%=job != null ? job.getId() : ""%>"
		></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol"
			active="<%=tabId%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform">
			<tr>
				<th class="itemstatus">
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermission %>"
						visible="<%=transformation.isRemoved()%>" 
					/>
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this transformation" : "You do not have permission to edit this transformation"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!transformation.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this transformation" : "You do not have permission to delete this transformation"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=transformation.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this transformation" : "You do not have permission to restore this transformation"%>" 
						/>
						<tbl:button 
							id="btnCopyJob"
							disabled="<%=!writePermission || !copyTransformationAllowed%>" 
							image="copy.png" 
							title="Copy&hellip;"
							visible="<%=job != null && plugin != null && plugin.isInteractive() %>"
							tooltip="<%=writePermission ? "Copy this transformation" : "You do not have permission to copy this transformation"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="transformation.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			</table>
			<table style="width: 100%; height: 15em;" class="bottomborder">
			<tr>
				<td style="width: 50%; height: 100%;">
				<table class="fullform" >
				<tr>
					<th>Name</th>
					<td><%=HTML.encodeTags(transformation.getName())%></td>
				</tr>
				<tr>
					<th>Experiment</th>
					<td><%=Base.getLinkedName(ID, experiment, false, writePermission)%></td>
				</tr>
				<tr>
					<th>Description</th>
					<td><%=HTML.niceFormat(transformation.getDescription())%></td>
				</tr>
				<tr>
					<th>Job</th>
					<td><%=Base.getLinkedName(ID, job, !readJob, false)%></td>
				</tr>
				<tr>
					<th class="subprompt">- started</th>
					<td>
						<%=job == null ? "" : dateTimeFormatter.format(job.getStarted())%>
					</td>
				</tr>
				<tr >
					<th class="subprompt">- ended</th>
					<td>
						<%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%>
					</td>
				</tr>
				<tr class="dynamic">
					<th class="subprompt">- server</th>
					<td>
						<%=job == null ? "" : HTML.encodeTags(job.getServer())%>
					</td>
				</tr>
				</table>
			</td>
			<td style="width: 50%; height: 100%;" class="leftborder">
				<table class="fullform" >
				<tr>
					<th>Plugin</th>
					<td><%=Base.getLinkedName(ID, plugin, 
							!readPlugin, plugin != null && plugin.hasPermission(Permission.WRITE))%></td>
				</tr>
				<tr>
					<th>Plugin configuration</th>
					<td><%=Base.getLinkedName(ID, configuration, !readConfiguration, 
						configuration != null && configuration.hasPermission(Permission.WRITE))%></td>
				</tr>
				<tbody class="sectionheader">
					<tr>
						<th colspan="2">Plugin parameters</th>
					</tr>
				</tbody>
				<%
				if (job != null)
				{
					for (String name : job.getParameterNames())
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = job.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
											item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
							<th class="subprompt"><span title="<%=description%>">- <%=name%></span></th>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
				%>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>
			</td>
			</tr>
			</table>
			</div>

			<jsp:include page="../../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Items related to this transformation" />
			</jsp:include>
			
			<base:section id="anaysis" title="Analysis subtree" context="<%=cc%>">
				<jsp:include page="../bioassaysets/analysis_tree.jsp">
					<jsp:param name="ID" value="<%=ID%>" />
					<jsp:param name="experiment_id" value="<%=experimentId%>" />
					<jsp:param name="transformation_id" value="<%=itemId%>" />
				</jsp:include>
			</base:section>
			</t:tab>
			</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
