<%-- $Id: view_item.jsp 6311 2013-08-23 12:52:14Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.Shareable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemProxy"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Session"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final int itemId = Values.getInt(request.getParameter("item_id"));
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final ItemContext cc = sc.getCurrentContext(Item.SYSTEM, "trashcan");
final DbControl dc = sc.newDbControl();
try
{
	BasicItem item = itemType.getById(dc, itemId);
	Set<ItemProxy> usingItems = item.getUsingItems();
	final boolean isUsed = usingItems != null && usingItems.size() > 0;
	final boolean writePermission = item.hasPermission(Permission.WRITE);
	final boolean deletePermission = item.hasPermission(Permission.DELETE);
	final boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
	final Shareable shareable = item instanceof Shareable ? (Shareable)item : null;
	final boolean isShared = shareable != null && shareable.isShared();
	final Removable removable = item instanceof Removable ? (Removable)item : null;
	final boolean isRemoved = removable != null && removable.isRemoved();
	String name = "";
	String description = "";
	if (item instanceof File)
	{
		File file = (File)item;
		name = file.getPath().toString();
		description = file.getDescription();
	}
	else if (item instanceof Directory)
	{
		Directory dir = (Directory)item;
		name = dir.getPath().toString();
		description = dir.getDescription();
	}
	else if (item instanceof Nameable)
	{
		Nameable nameable = (Nameable)item;
		name = nameable.getName();
		description = nameable.getDescription();
	}
	else
	{
		name = item.toString();
	}
	String link = Base.getLink(ID, HTML.encodeTags(name), item.getType(), itemId, writePermission);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, null, item);
	ExtensionsInvoker invoker = ExtensionsControl.useExtensions(jspContext,  
		"net.sf.basedb.clients.web.toolbar.item.all", 
		"net.sf.basedb.clients.web.toolbar.item.trashcan");
	%>
	<base:page title="<%="Trashcan - " + HTML.encodeTags(name) %>" id="view-page">
	<base:head scripts="tabcontrol-2.js,table.js,~trash.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement title="Trashcan" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=itemType.toString() + ": " + HTML.encodeTags(name)%>"
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>" data-item-type="<%=itemType.name()%>"></div>

		<t:tabcontrol id="main" subclass="content mastertabcontrol">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=isShared%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						image="deleted.png"
						tooltip="This item has been flagged for deletion."
						visible="<%=isRemoved%>" 
					/>
					<base:icon
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted."
						visible="<%=isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this item" : "You do not have permission to edit this item"%>" 
						/>
						<tbl:button 
							id="btnDeleteItem"
							disabled="<%=!deletePermission%>" 
							image="delete_permanently.png" 
							title="Delete permanently&hellip;"
							visible="<%=!isUsed%>"
							tooltip="<%=deletePermission ? "Permanently delete this item" : "You do not have permission to delete this item"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=isRemoved%>"
							tooltip="<%=writePermission ? "Restore this item" : "You do not have permission to restore this item"%>" 
						/>
						<tbl:button
							id="btnShare" 
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							visible="<%=shareable != null%>"
							tooltip="<%=sharePermission ? "Share this item to other user, groups and projects" : "You do not have permission to share this scan"%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="trash.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Type</th>
				<td><%=itemType.toString()%></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=link%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(description)%></td>
			</tr>
			</table>
			</div>

			<%
			if (isUsed)
			{
				%>
				<base:section
					id="useditems"
					title="<%="Items using " + HTML.encodeTags(name) + " (" + usingItems.size() + ")"%>"
					context="<%=cc %>"
					>
					<tbl:toolbar subclass="leftborder topborder rightborder">
						<tbl:button 
							id="btnDeleteItems"
							image="delete.png"
							title="Delete" 
							tooltip="Mark the selected items for deletion" 
						/>
						<tbl:button 
							id="btnRestoreItems"
							image="restore.png" 
							title="Restore" 
							tooltip="Restore the selected item" 
						/>
					</tbl:toolbar>
					<tbl:table
						id="usingItems"
						columns="all"
						action="index.jsp"
						sc="<%=sc%>"
					>
					<tbl:hidden 
						name="item_type"
						value="<%=itemType.name()%>"
					/>
					<tbl:hidden 
						name="item_id"
						value="<%=String.valueOf(itemId)%>"
					/>
					<tbl:columndef 
						id="name"
						title="Name/ID"
					/>
					<tbl:columndef
						id="type"
						title="Type"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:header 
									clazz="index"
									>&nbsp;</tbl:header>
								<tbl:header 
									clazz="check" 
									><base:icon 
										id="check.uncheck"
										image="check_uncheck.png" 
										tooltip="Check/uncheck all" 
										data-regexp="item:"
										style="align: left;"
									/></tbl:header>
								<tbl:header 
									clazz="icons" 
									>&nbsp;</tbl:header>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						int index = 0;
						for (ItemProxy proxy : usingItems)
						{
							index++;
							boolean denied = false;
							boolean writePermissionOnUsedBy = false;
							boolean usedByIsRemoved = false;
							boolean usedByRemovable = false;
							boolean usedByIsUsed = false;
							BasicItem usedBy = null;
							String usedByName = String.valueOf(proxy.getId());
							String usedByDescription = "";
							try
							{
								usedBy = proxy.getItem(dc);
								writePermissionOnUsedBy = usedBy.hasPermission(Permission.WRITE);
								usedByIsUsed = usedBy.isUsed();
								if (usedBy instanceof Removable)
								{
									usedByRemovable = true;
									usedByIsRemoved = ((Removable)usedBy).isRemoved();
								}
								if (usedBy instanceof File)
								{
									File file = (File)usedBy;
									usedByName = file.getPath().toString();
									usedByDescription = file.getDescription();
								}
								else if (usedBy instanceof Directory)
								{
									Directory dir = (Directory)usedBy;
									usedByName = dir.getPath().toString();
									usedByDescription = dir.getDescription();
								}
								else if (usedBy instanceof Nameable)
								{
									Nameable nameable = (Nameable)usedBy;
									usedByName = nameable.getName();
									usedByDescription = nameable.getDescription();
								}
								else
								{
									usedByName = usedBy.toString();
								}
							}
							catch (PermissionDeniedException ex)
							{
								denied = true;
							}
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check"
									><%
									if (usedByRemovable)
									{
										%><input 
											type="checkbox" 
											name="item:<%=proxy.getType().name()%>" 
											value="<%=proxy.getId()%>"
										><%
									}
									%></tbl:header>
								<tbl:header 
									clazz="icons" 
									><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=usedByIsRemoved%>"
									/>
									<base:icon 
										subclass="link auto-init"
										data-auto-init="show-using-items"
										data-item-type="<%=proxy.getType().name() %>"
										data-item-id="<%=proxy.getId() %>"
										image="used.png"
										tooltip="This item is used by other items"
										visible="<%=usedByIsRemoved &&  usedByIsUsed%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><%=Base.getLink(ID, HTML.encodeTags(usedByName), proxy.getType(), proxy.getId(), writePermissionOnUsedBy)%></tbl:cell>
								<tbl:cell column="type"><%=proxy.getType().toString()%></tbl:cell>
								<tbl:cell column="description"><%=HTML.niceFormat(usedByDescription)%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			if (item instanceof SharedItem)
			{
				%>
				<jsp:include page="../../common/share/list_share.jsp">
					<jsp:param name="ID" value="<%=ID%>" />
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="title" value="Shared to" />
				</jsp:include>
				<%
			}
			%>

		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.commit();
}

%>
